package Logging;

use strict;
use POSIX;

use vars qw|$verbosity|;
$verbosity = 5;

sub setVerbosity {
  $verbosity = shift;
}

sub date {
  return POSIX::strftime("%T", gmtime(time()));
}

sub error {
  print STDERR date(), " ERROR ", @_, "\n" if $verbosity > 0;
}

sub warning {
  print STDERR date(), " WARN  ", @_, "\n" if $verbosity > 1;
}

sub info {
  print STDERR date(), " INFO  ", @_, "\n" if $verbosity > 2;
}

sub debug {
  print STDERR date(), " DEBUG ", @_, "\n" if $verbosity > 3;
}

sub trace {
  print STDERR date(), " TRACE ", @_, "\n" if $verbosity > 4;
}

1;
