package Storage::Storage;

use strict;
use Storage::Bundle;

sub new {
  my $self = {};
  bless($self, shift);
  $self->_init(@_);
  return $self;
}

#
# common options:
# 'gzip' => 0|1
#

sub _init {
  my ($self, %options) = @_;
}

#
# bundle parameters:
# 'directory' => string
# bundle options:
# 'include' => ref([string])
# 'exclude' => ref([string])
# 'follow-symlinks' => 1
# 'user' => string
#

#
# Writes the descriptor (XML index) to the storage.
#

sub finish {
  my ($self, $descriptor) = @_;

  die "Pure virtual function call";
}

# -- Factory --

sub createMimeStorage {
  my ($gzip, $outputFile, $splitsize) = @_;
  require Storage::MimeStorage;
  return Storage::MimeStorage->new('gzip' => $gzip,
                                   'output_file' => $outputFile,
                                   'split_size' => $splitsize);
}

#
# Additional option: splitsize. see the split(1) for the formats
#

sub createFileStorage {
  my ($gzip, $outputFile, $splitsize) = @_;
  require Storage::FileStorage;
  return Storage::FileStorage->new('gzip_bundle' => $gzip,
                                   'output_dir' => $outputFile,
                                   'split_size' => $splitsize);
}

1;
